﻿Public Class Form1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        Dim NowDate As Date = Date.Today
        Dim ThisMonthPayDate As Date = PayDate(NowDate)

        If NowDate = ThisMonthPayDate Then
            Label1.Text = "本日は給料日です"
        ElseIf NowDate < ThisMonthPayDate Then
            Label1.Text = String.Format( _
            "次の給料日は{0:yyyy年M月d日です}", ThisMonthPayDate)
        Else
            Dim NextPayDate As Date = PayDate(NowDate.AddMonths(1))
            Label1.Text = String.Format( _
            "次の給料日は{0:yyyy年M月d日です}", NextPayDate)
        End If

    End Sub

    Function PayDate(ByVal d As Date) As Date

        Dim CurrentDate As Date = New Date(d.Year, d.Month, 25)

        Do Until IsBusinessDate(CurrentDate)
            CurrentDate = CurrentDate.AddDays(-1)
        Loop

        Return CurrentDate

    End Function

    Function IsBusinessDate(ByVal d As Date) As Boolean

        If d.DayOfWeek = DayOfWeek.Saturday Or d.DayOfWeek = _
        DayOfWeek.Sunday Then
            Return False
        Else
            Return True
        End If

    End Function

End Class
