﻿Public Class Form1

    Dim YubinList As List(Of String)

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        If YubinList Is Nothing Then
            ReadFile()
        End If

        Dim SearchNum As String = TextBox1.Text
        SearchNum = SearchNum.Replace("-", "")

        ListBox1.Items.Clear()
        For i As Integer = 0 To YubinList.Count - 1
            If SearchNum = YubinList(i).Substring(0, Math.Min( _
            SearchNum.Length, YubinList(i).Length)) Then
                ListBox1.Items.Add(HyphenString(YubinList(i)))
            End If
        Next

    End Sub

    Sub ReadFile()

        YubinList = New List(Of String)()

        Dim YubinFileName = Path.Combine(Application.StartupPath, _
        "Yubin.txt")

        Dim fs As FileStream = New FileStream(YubinFileName, _
        FileMode.Open)
        Dim sr As StreamReader = New StreamReader(fs, _
        Encoding.GetEncoding("shift_jis"))
        Dim Buffer As String

        Buffer = sr.ReadLine()
        Do Until Buffer Is Nothing
            YubinList.Add(Buffer)
            Buffer = sr.ReadLine()
        Loop

        sr.Close()

    End Sub

    Function HyphenString(ByVal OldString As String) As String

        If OldString.Length > 6 Then
            Return OldString.Substring(0, 3) & "-" & _
            OldString.Substring(3)
        Else
            Return OldString
        End If

    End Function

End Class
