﻿Public Class Form1

    Enum State
        Normal
        Move0
        Move1
        Move2
        Move3
        Hit0
        Hit1
        Hit2
    End Enum

    Dim ButtonState() As State
    Dim PictureBoxes() As PictureBox
    Private Sub PictureBox_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseDown, PictureBox2.MouseDown

        If e.Button And Windows.Forms.MouseButtons.Left Then
            SetState(sender, State.Hit0)
        End If

    End Sub

    Private Sub PictureBox_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles PictureBox1.MouseEnter, PictureBox2.MouseEnter
        SetState(sender, State.Move0)
    End Sub

    Private Sub PictureBox_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles PictureBox1.MouseLeave, PictureBox2.MouseLeave
        SetState(sender, State.Normal)
    End Sub

    Sub SetState(ByVal p As PictureBox, ByVal s As State)

        Dim x As Integer = Array.IndexOf(PictureBoxes, p)
        If x <> -1 Then
            ButtonState(x) = s
        End If

    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        For i As Integer = 0 To PictureBoxes.GetUpperBound(0)

            Select Case ButtonState(i)
                Case State.Normal
                    PictureBoxes(i).Image = My.Resources.Move0
                Case State.Move0
                    PictureBoxes(i).Image = My.Resources.Move0
                    ButtonState(i) = State.Move1
                Case State.Move1
                    PictureBoxes(i).Image = My.Resources.Move1
                    ButtonState(i) = State.Move2
                Case State.Move2
                    PictureBoxes(i).Image = My.Resources.Move2
                    ButtonState(i) = State.Move3
                Case State.Move3
                    PictureBoxes(i).Image = My.Resources.Move3
                    ButtonState(i) = State.Move0
                Case State.Hit0
                    PictureBoxes(i).Image = My.Resources.Hit
                    ButtonState(i) = State.Hit1
                Case State.Hit1
                    ButtonState(i) = State.Hit2
                Case State.Hit2
                    ButtonState(i) = State.Move0
            End Select

        Next

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        PictureBoxes = New PictureBox(1) {PictureBox1, _
        PictureBox2}
        ButtonState = New State(PictureBoxes.GetUpperBound(0)) {}
        Timer1.Start()

    End Sub

End Class
