﻿Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        For Each f As FontFamily In FontFamily.Families
            ListBox1.Items.Add(f.Name)
        Next

    End Sub

    Private Sub FontChangeMethod(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BoldCheckBox.CheckedChanged, ItalicCheckBox.CheckedChanged, UnderCheckBox.CheckedChanged, StrikeCheckBox.CheckedChanged, ListBox1.SelectedIndexChanged

        Dim Styles() As FontStyle = New FontStyle() { _
        FontStyle.Bold, FontStyle.Italic, FontStyle.Underline, _
        FontStyle.Strikeout}
        Dim CheckBoxes() As CheckBox = New CheckBox() { _
        BoldCheckBox, ItalicCheckBox, UnderCheckBox, StrikeCheckBox}

        Dim MyFontFamily As FontFamily = New FontFamily(ListBox1.Text)

        Dim MyStyle As FontStyle = FontStyle.Regular
        Dim StyleSelected As Boolean = _
        MyFontFamily.IsStyleAvailable(MyStyle)

        For i As Integer = 0 To Styles.GetUpperBound(0)
            If MyFontFamily.IsStyleAvailable(Styles(i)) And _
            (CheckBoxes(i).Checked Or StyleSelected = False) Then
                MyStyle = MyStyle Or Styles(i)
                StyleSelected = True
            End If
        Next

        Label1.Font = New Font(MyFontFamily, Label1.Font.Size, MyStyle)

    End Sub

End Class
