﻿Public Class Form1

    Dim ColorStep As Integer
    Const EndStep As Integer = 20

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click, Button2.Click

        If ColorDialog1.ShowDialog() = _
        Windows.Forms.DialogResult.OK Then
            If sender Is Button1 Then
                Label1.ForeColor = ColorDialog1.Color
            Else
                Label2.ForeColor = ColorDialog1.Color
            End If
        End If
    End Sub

    Private Sub GoButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GoButton.Click

        ColorStep = 0
        Timer1.Start()

    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Dim BlendRed As Byte = GetBlend(Label1.ForeColor.R, _
        Label2.ForeColor.R)
        Dim BlendGreen As Byte = GetBlend(Label1.ForeColor.G, _
        Label2.ForeColor.G)
        Dim BlendBlue As Byte = GetBlend(Label1.ForeColor.B, _
        Label2.ForeColor.B)

        PictureBox1.BackColor = Color.FromArgb(BlendRed, _
        BlendGreen, BlendBlue)

        ColorStep += 1

        If ColorStep > EndStep Then
            Timer1.Stop()
        End If

    End Sub

    Function GetBlend(ByVal a1 As Integer, ByVal a2 As Integer) As Byte

        Dim x As Double = a1 + (a2 - a1) * (ColorStep / EndStep)
        Return CType(x, Byte)

    End Function

End Class
