﻿Imports System.Drawing.Drawing2D
Public Class Form1

    Const TotalSecond As Integer = 30
    Dim StartDate As Date
    Dim RestTime As Single = TotalSecond
    Dim BlinkCount, BlinkBorder1, BlinkBorder2 As Integer

    Private Sub PictureBox1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PictureBox1.Paint

        Dim g As Graphics = e.Graphics
        Dim MarkColor, BlinkColor1, BlinkColor2 As Color
        Dim BlinkSpan As Integer

        If RestTime < 2 Then
            BlinkSpan = 2
            BlinkColor1 = Color.Red
            BlinkColor2 = Color.Yellow
        ElseIf RestTime < 5 Then
            BlinkSpan = 3
            BlinkColor1 = Color.Orange
            BlinkColor2 = Color.Gold
        Else
            BlinkSpan = 5
            BlinkColor1 = Color.Bisque
            BlinkColor2 = Color.PeachPuff
        End If

        If BlinkCount <= BlinkBorder1 Then
            MarkColor = BlinkColor1
        ElseIf BlinkCount < BlinkBorder2 Then
            MarkColor = BlinkColor2
        Else
            BlinkBorder1 = BlinkCount + BlinkSpan
            BlinkBorder2 = BlinkCount + BlinkSpan * 2
            MarkColor = BlinkColor2
        End If

        g.Clear(Color.White)
        g.SmoothingMode = SmoothingMode.HighQuality

        Dim w As Integer = PictureBox1.Width * 0.8
        Dim r As Rectangle = New Rectangle(PictureBox1.Width * _
        0.1, PictureBox1.Width * 0.1, w, w)

        Dim FillAngle As Single = 360 * (RestTime / TotalSecond)

        g.FillPie(New SolidBrush(MarkColor), r, 270, FillAngle)
        g.DrawPie(New Pen(Color.Chocolate, 1), r, 270, FillAngle)
        g.DrawArc(New Pen(Color.Chocolate, 1), r, 270 + FillAngle, _
        360 - FillAngle)
        Label1.Text = Math.Ceiling(RestTime) & " 秒"

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        BlinkCount = 0
        BlinkBorder1 = 0
        BlinkBorder2 = 0
        StartDate = Date.Now
        RestTime = TotalSecond
        Timer1.Start()

    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        BlinkCount += 1
        RestTime = Math.Max(0, TotalSecond - _
        (Date.Now - StartDate).TotalSeconds)

        PictureBox1.Invalidate()

        If RestTime <= 0 Then
            Timer1.Stop()
            RestTime = TotalSecond
            PictureBox1.Invalidate()
            MessageBox.Show("時間切れです", Me.Text, _
            MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If

    End Sub
End Class
