﻿Imports System.IO, System.Text
Public Class Form1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        Dim ReadFileName = Path.Combine(Application.StartupPath, _
                                        "Data.txt")
        Dim WriteFileName = Path.Combine(Application.StartupPath, _
                                         "Linenum.txt")

        Dim fs1, fs2 As FileStream
        Dim sr As StreamReader
        Dim sw As StreamWriter
        Dim Buffer As String
        Dim LineNum As Integer = 1

        Try
            fs1 = New FileStream(ReadFileName, FileMode.Open)
            fs2 = New FileStream(WriteFileName, FileMode.Create)
            sr = New StreamReader(fs1, Encoding.GetEncoding( _
            "shift_jis"))
            sw = New StreamWriter(fs2, Encoding.GetEncoding( _
            "shift_jis"))

            Buffer = sr.ReadLine()
            Do Until Buffer Is Nothing
                sw.WriteLine("{0:0000}:{1}", LineNum, Buffer)
                LineNum += 1
                Buffer = sr.ReadLine()
            Loop
            Label1.Text = "処理が終わりました"
        Catch ex As FileNotFoundException
            Label1.Text = "ファイルが見つかりません"
        Catch ex As UnauthorizedAccessException
            Label1.Text = "アクセス権がありません"
        Catch ex As IOException
            Label1.Text = ex.Message
        Finally
            If sr IsNot Nothing Then
                sr.Close()
            End If
            If sw IsNot Nothing Then
                sw.Close()
            End If
        End Try

    End Sub
End Class
