﻿Imports System.IO, System.ComponentModel
Public Class Form1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        Button1.Enabled = False
        BackgroundWorker1.RunWorkerAsync()

    End Sub

    Function WriteFile(ByVal fn As String, ByVal Worker As BackgroundWorker) As Boolean

        Dim r As Random = New Random()
        Dim sw As StreamWriter = New StreamWriter(fn)
        Dim s As String = _
        "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"
        Dim ReturnState As Boolean = False

        For i As Integer = 1 To 104857600
            If i Mod 1048576 = 0 Then
                Worker.ReportProgress(i / 1048576, _
                Path.GetFileName(fn))
            End If
            If Worker.CancellationPending Then
                ReturnState = True
                Exit For
            End If
            sw.Write(s.Chars(r.Next(s.Length)))
        Next

        sw.Close()
        Return ReturnState

    End Function
    Private Sub BackgroundWorker1_DoWork(ByVal sender As Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker1.DoWork

        For i As Integer = 1 To 5
            If WriteFile(Path.Combine(Application.StartupPath, _
            "Alphabet" & i), sender) Then
                e.Cancel = True
                Exit For
            End If
        Next

    End Sub

    Private Sub BackgroundWorker1_ProgressChanged(ByVal sender As Object, ByVal e As System.ComponentModel.ProgressChangedEventArgs) Handles BackgroundWorker1.ProgressChanged

        Label1.Text = e.UserState & "を処理中　" & _
        e.ProgressPercentage & "% 完了"

    End Sub

    Private Sub BackgroundWorker1_RunWorkerCompleted(ByVal sender As Object, ByVal e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles BackgroundWorker1.RunWorkerCompleted

        If e.Cancelled Then
            Label1.Text = "処理はキャンセルされました"
        ElseIf e.Error Is Nothing Then
            Label1.Text = "処理が終わりました"
        Else
            MessageBox.Show(e.Error.Message, Me.Text, _
            MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If

        Button1.Enabled = True

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        BackgroundWorker1.CancelAsync()
    End Sub

End Class
