﻿Public Class Form1

    Dim DSTspan, DiffSpan As TimeSpan
    Dim CityName As String

    Private Sub DSTToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DSTToolStripMenuItem.Click

        DSTToolStripMenuItem.Checked = Not _
        DSTToolStripMenuItem.Checked
        If DSTToolStripMenuItem.Checked Then
            DSTspan = New TimeSpan(1, 0, 0)
        Else
            DSTspan = New TimeSpan(0, 0, 0)
        End If

    End Sub

    Private Sub SydneyToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SydneyToolStripMenuItem.Click
        SetCity(sender, "シドニー", New TimeSpan(1, 0, 0))
    End Sub

    Private Sub LondonToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LondonToolStripMenuItem.Click
        SetCity(sender, "ロンドン", New TimeSpan(-9, 0, 0))
    End Sub

    Private Sub NewyorkToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewyorkToolStripMenuItem.Click
        SetCity(sender, "ニューヨーク", New TimeSpan(-14, 0, 0))
    End Sub

    Private Sub HonoluluToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HonoluluToolStripMenuItem.Click
        SetCity(sender, "ホノルル", New TimeSpan(-19, 0, 0))
    End Sub

    Private Sub BerlinToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BerlinToolStripMenuItem.Click
        SetCity(sender, "ベルリン", New TimeSpan(-8, 0, 0))
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        DisplayTime()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        SetCity(LondonToolStripMenuItem, "ロンドン", _
        New TimeSpan(-9, 0, 0))
    End Sub

    Sub SetCity(ByVal MyItem As ToolStripMenuItem, ByVal c As String, ByVal df As TimeSpan)

        For Each d As ToolStripMenuItem _
        In CityToolStripMenuItem.DropDownItems
            d.Checked = False
        Next
        MyItem.Checked = True

        CityName = c
        DiffSpan = df
        DisplayTime()

    End Sub

    Sub DisplayTime()

        Dim TokyoTime As Date = Date.Now
        Dim CityTime As Date = TokyoTime + DiffSpan + DSTspan
        TokyoTimeLabel.Text = String.Format( _
        "{0:yyyy年M月d日  HH:mm:ss}", TokyoTime)
        CityTimeLabel.Text = String.Format( _
        "{0:yyyy年M月d日  HH:mm:ss}", CityTime)
        CityLabel.Text = CityName

    End Sub

End Class
